%define anolis_release 1

%{?filter_provides_in: %filter_provides_in %{_httpd_moddir}/.*\.so$}
%{?filter_setup}

Name:           mod_wsgi
Version:        4.9.4
Release:        %{anolis_release}%{?dist}
Summary:        A WSGI interface for Python web applications in Apache
License:        ASL 2.0
URL:            https://modwsgi.readthedocs.io/
Source0:        https://github.com/GrahamDumpleton/mod_wsgi/archive/%{version}.tar.gz#/mod_wsgi-%{version}.tar.gz
Source1:        wsgi.conf
Source2:        wsgi-python3.conf
Patch1:         mod_wsgi-4.5.20-exports.patch

BuildRequires:  httpd-devel gcc make
BuildRequires:  python3-sphinx python3-sphinx_rtd_theme
BuildRequires:  python3-setuptools python3-devel

%description
The mod_wsgi adapter is an Apache module that provides a WSGI compliant
interface for hosting Python based web applications within Apache. The
adapter is written completely in C code against the Apache C runtime and
for hosting WSGI applications within Apache has a lower overhead than using
existing WSGI adapters for mod_python or CGI.

%package -n python3-%{name}
Summary:        %summary
Requires:       httpd-mmn = %{_httpd_mmn}
Provides: 	mod_wsgi = %{version}-%{release}
Obsoletes: 	mod_wsgi < %{version}-%{release}

%description -n python3-%{name}
The mod_wsgi adapter is an Apache module that provides a WSGI compliant
interface for hosting Python based web applications within Apache. The
adapter is written completely in C code against the Apache C runtime and
for hosting WSGI applications within Apache has a lower overhead than using
existing WSGI adapters for mod_python or CGI.

%package -n python3-%{name}-doc
Summary:        Documentation files for python3-%{name}
Requires:       python3-%{name} = %{version}-%{release}
BuildArch:      noarch

%description -n python3-%{name}-doc
The python3-%{name}-doc package contains documentation files for python3-%{name}.

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%make_build -C docs html

export LDFLAGS="$RPM_LD_FLAGS -L%{_libdir}"
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%configure --enable-shared --with-apxs=%{_bindir}/apxs --with-python=%{python3}
%make_build
%py3_build

%install
%make_install LIBEXECDIR=%{_httpd_moddir}
mv  $RPM_BUILD_ROOT%{_httpd_moddir}/mod_wsgi{,_python3}.so

install -d -m 755 $RPM_BUILD_ROOT%{_httpd_modconfdir}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_httpd_modconfdir}/10-wsgi-python3.conf

%py3_install
mv $RPM_BUILD_ROOT%{_bindir}/mod_wsgi-express{,-3}

%files -n python3-%{name}
%license LICENSE
%config(noreplace) %{_httpd_modconfdir}/*wsgi-python3.conf
%{_httpd_moddir}/mod_wsgi_python3.so
%{python3_sitearch}/mod_wsgi-*.egg-info
%{python3_sitearch}/mod_wsgi
%{_bindir}/mod_wsgi-express-3

%files -n python3-%{name}-doc
%doc CREDITS.rst README.rst

%changelog
* Thu May 11 2023 happy_orange <songnannan@linux.alibaba.com> - 4.9.4-1
- init package
